.TH XScreenSaver 1 "10-May-97" "X Version 11"
.SH NAME
hopalong - draw real plane fractals
.SH SYNOPSIS
.B hopalong
[\-display \fIhost:display.screen\fP] [\-foreground \fIcolor\fP] [\-background \fIcolor\fP] [\-window] [\-root] [\-mono] [\-install] [\-visual \fIvisual\fP] [\-ncolors \fIinteger\fP] [\-delay \fImicroseconds\fP] [\-cycles \fIinteger\fP] [\-count \fIinteger\fP] [\-jong] [\-no\-jong] [\-jong] [\-no\-sine]

.SH DESCRIPTION
The \fIhopalong\fP program generates real plane fractals as described in
the September 1986 issue of Scientific American.
.SH OPTIONS
.I hopalong
accepts the following options:
.TP 8
.B \-window
Draw on a newly-created window.  This is the default.
.TP 8
.B \-root
Draw on the root window.
.TP 8
.B \-mono 
If on a color display, pretend we're on a monochrome display.
.TP 8
.B \-install
Install a private colormap for the window.
.TP 8
.B \-visual \fIvisual\fP
Specify which visual to use.  Legal values are the name of a visual class,
or the id number (decimal or hex) of a specific visual.
.TP 8
.B \-ncolors \fIinteger\fP
How many colors should be used (if possible).  Default 200.
The colors used cycle through the hue, making N stops around
the color wheel.
.TP 8
.B \-cycles \fIinteger\fP
How long to run each batch.  Default 2500 pixels.
.TP 8
.B \-count \fIinteger\fP
How many pixels should be drawn before a color change.  Default 1000.
.TP 8
.B \-jong \fIinteger\fP
.TP 8
.B \-no\-jong \fIinteger\fP
Whether to use the Jong format (default is to choose randomly.)

.TP 8
.B \-sine \fIinteger\fP
.TP 8
.B \-no\-sine \fIinteger\fP
Whether to use the Sine format (default is to choose randomly.)

.SH ENVIRONMENT
.PP
.TP 8
.B DISPLAY
to get the default host and display number.
.TP 8
.B XENVIRONMENT
to get the name of a resource file that overrides the global resources
stored in the RESOURCE_MANAGER property.
.SH SEE ALSO
.BR X (1),
.BR xscreensaver (1),
.BR xlock (1)
.SH COPYRIGHT
Copyright \(co 1988-91 by Patrick J. Naughton.

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation. 
.SH AUTHOR
Patrick J. Naughton <naughton@eng.sun.com>, 23-mar-88.

Ability to run standalone or with \fIxscreensaver\fP added by 
Jamie Zawinski <jwz@netscape.com>, 13-aug-92, and again on 10-May-97.
